<?php

## do single rows start and end with a pipe? (yes/no)
$row_starts_with_pipe = "no";
$row_ends_with_pipe = "no";

$fp = fopen("php://stdin", "r");
while($line = fgets($fp, 1024)){
	$input[] = $line;
}
fclose($fp);

if(count($input) <= 0){
	echo "ERROR: No text provided";
	exit();
}

//input = file("testFile.txt");

$row_starts_with_pipe == "no" ? $pipe_leading = "" : $pipe_leading = "|";
$row_ends_with_pipe == "no" ? $pipe_trailing = "" : $pipe_trailing = "|";

$current = array();
$headline = "";

## saves the string-length of the cells
$lengthCounter = array();

## removing empty rows
for($i = 0; $i < count($input); $i++){
	if(trim($input[$i]) != ""){

		$current_line = trim($input[$i]);
## removing leading and final |			
		if(substr($current_line, 0, 1) == "|"){
			$current_line = substr($current_line, 1);
		}
		if(substr($current_line, strlen($current_line) - 1) == "|"){
			$current_line = substr($current_line, 0, strlen($current_line) - 1);
		}

## check for tablehead					
		$headChar_count = substr_count($current_line, "|") +
		 			  substr_count($current_line, "-") +
		 			  substr_count($current_line, ".") +
		 			  substr_count($current_line, ":") +
		 			  substr_count($current_line, " ") +
		 			  substr_count($current_line, "	");

		if(strlen($current_line) == $headChar_count){
			$headline = $current_line;
		}
		else{
			$pieces = explode("|", $current_line);
			$addRow = array();
			for($y = 0; $y < count($pieces); $y++){
				$cellValue = trim($pieces[$y]);
				$addRow[] = $cellValue;
				
				$stringLen = strlen(utf8_decode($cellValue));
				if($lengthCounter[$y] < $stringLen){			
					$lengthCounter[$y] = $stringLen;
				}
			}
			$current[] = $addRow;
		}
	}
}

$exploded = $current;

## number of cols
$countColumns = 0;
foreach($exploded as $singleRow){
	if(count($singleRow) > $countColumns){
		$countColumns = count($singleRow);
	}
}

## fill with spaces
for($i = 0; $i < count($exploded); $i++){
	for($j = 0; $j < count($exploded[$i]); $j++){
		$exploded[$i][$j] = str_pad($exploded[$i][$j], $lengthCounter[$j]);
	}
}

## head
if($countColumns > count($exploded[0])){
	// mögliche leere Zellen anhängen
	for($y = count($exploded[0]); $y < $countColumns; $y++){
		array_push($exploded[0], str_pad(" ", $lengthCounter[$y], " "));
	}
}
$finalArray[0] = $pipe_leading." ".implode(" | ", $exploded[0]);


$tableDivider_array = explode("|", $headline);
for($i = 0; $i < $countColumns; $i++){
## Nach Ausrichtungs : suchen
	$start = $end = ""; ## Ausrichtungen anhängen
	$signCounter = $lengthCounter[$i];
	$currentPiece = trim($tableDivider_array[$i]);
	if(substr($currentPiece, 0, 1) == ":"){
		$start = ":";
		$signCounter--;
	}
	if(substr($currentPiece, strlen($currentPiece) - 1, 1) == ":"){
		$end = ":";
		$signCounter--;
	}
	
	$tableDivider[] = $start.str_pad("-", $signCounter, "-").$end;
}
$finalArray[1] = $pipe_leading." ".implode(" | ", $tableDivider); 


for($i = 1; $i < count($exploded); $i++){
	if($countColumns > count($exploded[$i])){
		for($y = count($exploded[$i]); $y < $countColumns; $y++){
			array_push($exploded[$i], str_pad(" ", $lengthCounter[$y], " "));
		}
	}
	$finalArray[] = $pipe_leading." ".implode(" | ", $exploded[$i]);
}

$string = implode(" ".$pipe_trailing."\n", $finalArray);
echo $string." ".$pipe_trailing;

?>